;(function() {
  var doc = document;
  var wz = new Object();
  
  var onInputInfo;
  var onKickInfo;
  var onGiftsInfo;
  var onInputName;
  var onGiftsName;
  var onKickName;
  var addFriendName;
  var onInitValue = new Array;
  
  Array.prototype.contains = function ( needle ) {
	  for (i in this) {
	    if (this[i] == needle) return true;
	  }
	  return false;
	}
  
  var getFnName = function(callee){
      var _callee = callee.toString().replace(/[\s\?]*/g,""),
      comb = _callee.length >= 50 ? 50 :_callee.length;
      _callee = _callee.substring(0,comb);
      var name = _callee.match(/^function([^\(]+?)\(/);
      if(name && name[1]){
        return name[1];
      }
      var caller = callee.caller,
      _caller = caller.toString().replace(/[\s\?]*/g,"");
      var last = _caller.indexOf(_callee),
      str = _caller.substring(last-30,last);
      name = str.match(/var([^\=]+?)\=/);
      if(name && name[1]){
        return name[1];
      }
      return "anonymous"
    };
  
	function onInit(rjson){//注册
		onInitValue = rjson.apilists;
		if (window.app) {
			var onjson = {'code':0,'msg':'sd卡测试数据'};
		}else{
			var onjson = {'code':1,'msg':'失败'};
		}
		return onjson;
	}
	
	function showNavBar(rjson){//导航栏显示隐藏
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.showNavBar(JSON.stringify(rjson));
		}
	}
	
	function silence(rjson){//免打扰开关，ture打开，false默认关闭。
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.silence(JSON.stringify(rjson));
		}
	}
	
	function closePage(){//关闭当前页面
		if(onInitValue.contains(getFnName(arguments.callee))){
		  app.closePage()
		 }
	}
	
	function refreshPage(){//刷新当前页面
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.refreshPage();
		}
	}
	
	function onBackHome(){//关闭所有webview
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.onBackHome()
		}
	}
	
	function userPage(rjson){//打开用户界面
		if(onInitValue.contains(getFnName(arguments.callee))){
	 	 app.userPage(JSON.stringify(rjson));
	 }
	}
	
	function queryItems(rjson){//获取道具信息。tids:道具ID组
		if(onInitValue.contains(getFnName(arguments.callee))){
			var re = app.queryItems(JSON.stringify(rjson))
			return re;
		}
	}
	
	function queryDiams(){//获取钻石数量。
		if(onInitValue.contains(getFnName(arguments.callee))){
			var re = app.queryDiams()
			return re;
		}
	}
	
	function showPay(rjson){//打开商城
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.showPay(JSON.stringify(rjson))
		}
	}
	
	function buyItem(rjson){//单个购买道具页面
		if(onInitValue.contains(getFnName(arguments.callee))){
			var re = app.buyItem(JSON.stringify(rjson))
			return re;
		}
	}
	
	function useItem(rjson){//使用游戏物品
		if(onInitValue.contains(getFnName(arguments.callee))){
			var re = app.useItem(JSON.stringify(rjson))
			return re;
		}
	}
	
	function talkingMod(rjson){//type1:CHANNEL_PROFILE_COMMUNICATION,type2:CHANNEL_PROFILE_LIVE_BROADCASTING,type3:CHANNEL_PROFILE_GAME
		if(onInitValue.contains(getFnName(arguments.callee))){
			var re = app.talkingMod(JSON.stringify(rjson))
			return re;
		}
	}
	
	function joinTalking(rjson){//平台编号,房间编号,频道编号,平台指定ID，可以写0
		if(onInitValue.contains(getFnName(arguments.callee))){
			var re = app.joinTalking(JSON.stringify(rjson))
			return re;
		}
	}
	
	function onJoinTalking(rjson){
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.onJoinTalking(JSON.stringify(rjson))
		}
	}
	
	function setTalking(rjson){//onoff:打开关闭，talkid:=0表示关闭自己的通话>0表示关闭指定用户的通话。（不播放）
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.setTalking(JSON.stringify(rjson))
		}
	}
	
	function leaveTalking(){//离开频道
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.leaveTalking()
		}
	}
	
	function voiceWindow(rjson){//打开视频窗口
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.voiceWindow(JSON.stringify(rjson));
		}
	}
	
	function showInvitation(){//显示邀请界面
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.showInvitation()
		}
	}
	
	function showRules(rjson){//显示游戏规则
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.showRules(JSON.stringify(rjson))
		}
	}
	function bugReports(rjson){//注册举报理由
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.setReports(JSON.stringify(rjson));
		}
	}
	
	function onInput(callback){
		onInputName = 'CB_' + Date.now() + '_' + Math.ceil(Math.random() * 10);
		window[onInputName] = callback;
	}
	
	function onInputCallback(data) {
  	window[onInputName](data);
  	//delete window[onInputName];
  }	
	
	function onGifts(callback){
		onGiftsName = 'CB_' + Date.now() + '_' + Math.ceil(Math.random() * 10);
		window[onGiftsName] = callback;
	}
	
	function onGiftsCallback(data) {
  	window[onGiftsName](data);
  	//delete window[onGiftsName];
  }	
  
	function onKick(callback){
		onKickName = 'CB_' + Date.now() + '_' + Math.ceil(Math.random() * 10);
		window[onKickName] = callback;
	}
	
	function onKickCallback(data) {
  	window[onKickName](data);
  	//delete window[onKickName];
  }	
	
	function queryNexus(rjson,callback){
		queryNexusName = 'CB_' + Date.now() + '_' + Math.ceil(Math.random() * 10);
		window[queryNexusName] = callback;
		app.queryNexus(JSON.stringify(rjson))
	}
	
	function queryNexusCallback(data) {
  	window[queryNexusName](data);
  	delete window[queryNexusName];
  }	
	
	function setKeyValue(rjson){//写入配置
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.setKeyValue(JSON.stringify(rjson))
		}
	}
	
	function getKeyValue(rjson){//读取配置
		if(onInitValue.contains(getFnName(arguments.callee))){
			var returnV = app.getKeyValue(JSON.stringify(rjson))
			return returnV;
		}
	}
	
	function spdDiams(rjson){//使用钻石
		if(onInitValue.contains(getFnName(arguments.callee))){
			var returnV = app.spdDiams(JSON.stringify(rjson))
			return returnV;
		}
	}
	
	function changeMaster(rjson){//房主变更
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.changeMaster(JSON.stringify(rjson))
		}
	}
	
	function addFriend(rjson,callback){  //添加某用户为自己好友
		if(onInitValue.contains(getFnName(arguments.callee))){
			addFriendName = 'CB_' + Date.now() + '_' + Math.ceil(Math.random() * 10);
			window[addFriendName] = callback;
			app.addFriend(JSON.stringify(rjson))
		}
	}
	
	function addFriendCallback(data){
		window[addFriendName](data);
	}
	
	function barrage(rjson){
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.barrage(JSON.stringify(rjson))
		}
	}
	function barrageMess(rjson){
		if(onInitValue.contains(getFnName(arguments.callee))){
			app.barrageMess(JSON.stringify(rjson))
		}
	}
	window.wz = {
		onInit:onInit,
		showNavBar:showNavBar,
		silence:silence,
		closePage:closePage,
		refreshPage:refreshPage,
		onBackHome:onBackHome,
		userPage:userPage,
		queryItems:queryItems,
		queryDiams:queryDiams,
		
		showPay:showPay,
		buyItem:buyItem,
		useItem:useItem,
		
		talkingMod:talkingMod,
		joinTalking:joinTalking,
		onJoinTalking:onJoinTalking,
		setTalking:setTalking,
		leaveTalking:leaveTalking,
		
		voiceWindow:voiceWindow,
		
		showInvitation:showInvitation,
		showRules:showRules,
		bugReports:bugReports,
		
		onInput:onInput,
		onInputCallback:onInputCallback,
		onGifts:onGifts,
		onGiftsCallback:onGiftsCallback,
		onKick:onKick,
		onKickCallback:onKickCallback,
		queryNexus:queryNexus,
		queryNexusCallback:queryNexusCallback,
		
		
		setKeyValue:setKeyValue,
		getKeyValue:getKeyValue,
		spdDiams:spdDiams,
		changeMaster:changeMaster,
		addFriend:addFriend,
		addFriendCallback:addFriendCallback,
		
		barrage:barrage,
		barrageMess:barrageMess
		
	}

})();
